$("#importFilesBTN").on('click', function(event) {
  jsonDataToReport(document.getElementById("jsonLoadMultiple"), function(val){
     // reset the data when the the data is reloaded in
    tableDataFirstInstanceDecision = new Array();
    tableDataPersonalInterviewForm = new Array();
    tabulatorCreateMainTable(val);
 });
});

$("#importFolderBTN").on('click', function(event) {
  
  $('textarea', '#reportCommentsContainer').val('');
  jsonDataToReport(document.getElementById("jsonLoadFolder"), function(val){
    // reset the data when the the data is reloaded in
    tableDataFirstInstanceDecision = new Array();
    tableDataPersonalInterviewForm = new Array();

    tabulatorCreateMainTable(val);
   
 });
});

$("#filterManageShowHide").on('click', function(event) {
  $('#filterManage ul').toggle();
  $('#showHideFilters').toggle();
});


$("#checkall_filters").on('change', function(event) {

  $('#the-throbber').css('display', 'block');
 
  if($(this).is(':checked')){
    $('#filterManage input[type="checkbox"]').each(
      function(index,item){
        if($(item).attr('id')=='checkall_filters') {
          return;
        }


        let field = $(this).attr('id').replace('filterManage_','');
        
          reportTable.showColumn(field);
          
          $(item).prop("checked", true);



        if(index==$('#filterManage input[type="checkbox"]').length-2){
          $('#the-throbber').hide();
        }

        setTimeout(function(){ 
          reportTable.redraw(true);

         }, 750);

      }



    );
  }else{ 
    $('#filterManage input[type="checkbox"]').each(
      function(index,item){

        if($(item).attr('id')=='checkall_filters') {
          return;
        }

        let field = $(this).attr('id').replace('filterManage_','');
          reportTable.hideColumn(field)

          $(item).prop("checked", false);

        if(index==$('#filterManage input[type="checkbox"]').length-2){
          $('#the-throbber').hide();
        }

      }
    );
  }
});

function addIndicatorReport(){ 
  // Foe the new report calulate data based on what is currently filtered
  // this is done via syncing up with the id that has been set for rows in tabulator
  // if the row is active can check/match against this within the global json data 
  // if its not found, the row will not be added for calc

  var availableRows = [];
  $('tbody', '#reportPageTable').remove();

  if(reportTable) {
    var rows = reportTable.getRows('active');
    for(var row in rows) {
      availableRows.push(rows[row].getIndex());
    }
  }

  var dataTotals = {};
  dataTotals['high'] = {}
  dataTotals['low'] = {}
  dataTotals['medium'] = {}
  dataTotals['totalCount'] = 0;
  dataTotals['totals'] = {};
  dataTotals['totalsComplete'] = {};

  var useReport = '#personalInterviewForm';     
  
  for(var jsonFileKey in jsonLoadedArray){

    json = jsonLoadedArray[jsonFileKey];


    if(availableRows.indexOf(json['id']) < 0){
      continue;
    }

    //&& Object.keys(dataTotals['totals']).length>0

    if($('input[name="selected_report"]:checked').val() != 'personal') {
      useReport = '#firstInstanceDecision';
    }
    
    $('label.assessment-form-label', useReport).each(function(x,y){

      dataTotals['totalCount']++;

      var labelID = $(y).attr('id').replace('Label','');
      
      if(typeof dataTotals['totals'][labelID] == 'undefined') {
        dataTotals['totals'][labelID] = 0;
      }
      
      if(typeof dataTotals['totalsComplete'][labelID] == 'undefined') {
        dataTotals['totalsComplete'][labelID] = 0;
      }

      dataTotals['totalsComplete'][labelID]++;

      if(typeof dataTotals['high'][labelID] == 'undefined') {
        dataTotals['high'][labelID] = {};
        dataTotals['high'][labelID]['count'] = 0;
        dataTotals['high'][labelID]['label'] = $('p',y).text();
      }

      if(typeof dataTotals['medium'][labelID] == 'undefined') {
        dataTotals['medium'][labelID] = {};
        dataTotals['medium'][labelID]['count'] = 0;
        dataTotals['medium'][labelID]['label'] = $('p',y).text();
      }

      if(typeof dataTotals['low'][labelID] == 'undefined') {
        dataTotals['low'][labelID] = {};
        dataTotals['low'][labelID]['count'] = 0;
        dataTotals['low'][labelID]['label'] = $('p',y).text();
      }

  
      switch( array_flip(selectOptionsTrans[labelID][0])[json[labelID]]) {
        case '03':
          dataTotals['medium'][labelID]['count']++;
          dataTotals['totals'][labelID]++;
          break;
        case '02':
          dataTotals['high'][labelID]['count']++;
          dataTotals['totals'][labelID]++;          
          break;
        case '01':
          dataTotals['low'][labelID]['count']++;
          dataTotals['totals'][labelID]++;
          break;
      }
    });

  }

  var rowCount = 0;
  var i = 1;
  var tbody = '';

  if(dataTotals == null || Object.keys(dataTotals['totals']).length<=0) {
    return;
  }



  for(var reportDataKey in dataTotals['totals']) {

    var low = 0;
    var medium = 0;
    var high = 0;

    if(dataTotals['high'][reportDataKey]['count']!=0) {
      high = (dataTotals['high'][reportDataKey]['count']*100/dataTotals['totals'][reportDataKey]).toFixed(2)
    }

    if(dataTotals['medium'][reportDataKey]['count']!=0) {
      medium= (dataTotals['medium'][reportDataKey]['count']*100/dataTotals['totals'][reportDataKey]).toFixed(2)
    }

    if(dataTotals['low'][reportDataKey]['count']!=0) {
      low = (dataTotals['low'][reportDataKey]['count']*100/dataTotals['totals'][reportDataKey]).toFixed(2)
    }

    if(rowCount==0) {
      tbody = $('<tbody></tbody>')
    }

    rowCount++;
    i++;

    $(tbody).append('<tr><td>'+ dataTotals['high'][reportDataKey]['label'] +'</td>'
    +'<td class="row-correct" id="'+ reportDataKey +'-correct">'+ Math.round(low) +'%</td>'
    +'<td class="row-minorErrors" id="'+ reportDataKey +'-minorErrors">'+ Math.round(high) +'%</td>'
    +'<td class="row-signifcantErrors" id="'+ reportDataKey +'-signifcantErrors">'+  Math.round(medium) +'%</td>'
    +'<td class="row-total" id="'+ reportDataKey +'-total">'+ dataTotals['totals'][reportDataKey] +'/'+ dataTotals['totalsComplete'][reportDataKey] +'</td>'
    +'</tr>'
    );

    if((rowCount==10 || i == Object.keys(dataTotals['totals']).length)) {
      $('table', '#reportPageTable').append(tbody);
      $('table', '#reportPageTable').append('<tbody  class="html2pdf__page-break tbody_PageBreak"></tbody>');
      tbody =  '';
      rowCount = 0;
    }
  }
}

function tableColsForSelectedType(){


  if($('input[name="selected_report"]:checked').val()=='personal') {
    $('#reportCommentsInterviews').show();
    $('#reportCommentsDecisions').hide();
    
    return [
      {title:"overallQualityData", field:"overallQuality-dataHidden", frozen:true, visible:false},
      {title:recuringTrans["totalApplicableValue"], field:"totalApplicableValue", bottomCalc:"sum", frozen:true, width:105, visible:false},
      {title:recuringTrans["totalCorrectValue"], field:"totalCorrectValue", hozAlign:"right", sorter:"number", bottomCalc:"sum", frozen:true, width:80, visible:false},
      {title:recuringTrans["totalMinorErrorsValue"], field:"totalMinorErrorsValue", bottomCalc:"sum", frozen:true, width:135, visible:false},
      {title:recuringTrans["percentageMinorErrorsValue"], field:"percentageMinorErrorsValue", frozen:true, width:105, visible:false},
      {title:recuringTrans["percentageSignificantErrorsValue"], field:"percentageSignificantErrorsValue", frozen:true, width:105, visible:false},
      {title:recuringTrans["overallQuality"], field:"overallQuality",  sorter:function(a, b, aRow, bRow, column, dir, sorterParams){

        var obj=  selectOptionsTrans['overallQuality'][0];
        a = Object.entries(obj).find(i => i[1] == a)[0];
        b = Object.entries(obj).find(i => i[1] == b)[0];
        return a - b; //you must return the difference between the two values
    }, width:160, headerFilter:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter,editorParams:{multiValueRow: true}},
      {title:recuringTrans["caseFileReference"], field:"caseFileReference", headerSort:true,  headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["interviewer"], field:"interviewer", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["teamUnit"], field:"teamUnit", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["countryOfOrigin"], field:"countryOfOrigin", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
    //  {title:recuringTrans["specialNeeds"], field:"specialNeeds", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, editorParams:{multiValueRow: true}},
      {width:150,title:recuringTrans["specialNeeds"], field:"specialNeeds", sorter:function(a, b, aRow, bRow, column, dir, sorterParams){

        var obj=  selectOptionsTrans['specialNeeds'][0];
        a = Object.entries(obj).find(i => i[1] == a[0])[0];
        b = Object.entries(obj).find(i => i[1] == b[0])[0];

        return a - b; //you must return the difference between the two values
    }, headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, editorParams:{multiValueRow: true}},

      {width:282,title:recuringTrans["dateOfLodgingTheApplication"], field:"dateOfLodgingTheApplication", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
      {width:282,title:recuringTrans["dateOfInterview"], field:"dateOfInterview", headerFilterPlaceholder:recuringTrans["filterPlaceholder"], headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
      //{title:recuringTrans["interviewConductedThroughInterpreter"], field:"interviewConductedThroughInterpreter", headerSort:false, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"interviewConductedThroughInterpreter"}},
      {title:recuringTrans["languageOfTheInterview"], field:"languageOfTheInterview", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"languageOfTheInterview"}},
      //{title:recuringTrans["legalRepresentativePresentDuringTheInterview"], headerSort:false, field:"legalRepresentativePresentDuringTheInterview", headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"legalRepresentativePresentDuringTheInterview"}, visible:false},
      //{title:recuringTrans["dateOfDecision"], field:"dateOfDecision", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
      {width:160,title:recuringTrans["groundsForTheApplication"], field:"groundsForTheApplication", headerSort:true, sorter:function(a, b, aRow, bRow, column, dir, sorterParams){


        var obj=  selectOptionsTrans['groundsForTheApplication'][0];
        a = Object.entries(obj).find(i => i[1] == a[0])[0];
        b = Object.entries(obj).find(i => i[1] == b[0])[0];
        
        return a - b; //you must return the difference between the two values
    }, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"groundsForTheApplication"}},
      {title:recuringTrans["decisionOutcome"], field:"decisionOutcome", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"decisionOutcome"}},
      {title:recuringTrans["qualityAssessor"], field:"qualityAssessor", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"qualityAssessor"}},
      //{title:recuringTrans["additionalInformationSpecificToNationalSystem"], headerSort:false, field:"additionalInformationSpecificToNationalSystem", headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"additionalInformationSpecificToNationalSystem"}, visible:false},
      {width:282,title:recuringTrans["assesmentDate"], field:"assesmentDate", headerFilter:true, headerSort:true,  headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
      {title:recuringTrans["conclusion"], field:"conclusion", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"conclusion"}},
      
      {title:recuringTrans["sexOfTheApplicant"], field:"sexOfTheApplicant", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"sexOfTheApplicant"}},
      {title:recuringTrans["ageOfTheApplicant"], field:"ageOfTheApplicant", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"ageOfTheApplicant"}},
      {width:160,title:recuringTrans["durationOfTheInterview"], field:"durationOfTheInterview", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"durationOfTheInterview"}},
      {width:170,title:recuringTrans["interviewConductedThroughInterpreter"], field:"interviewConductedThroughInterpreter", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"interviewConductedThroughInterpreter"}},
      {width:220,title:recuringTrans["legalRepresentativePresentDuringTheInterview"], headerSort:true, field:"legalRepresentativePresentDuringTheInterview", headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"legalRepresentativePresentDuringTheInterview"}},
      {title:recuringTrans["assessmentBasedOn"], field:"assessmentBasedOn", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"assessmentBasedOn"}},

      {title:recuringTrans["percentageCorrectValue"], field:"percentageCorrectValue", hozAlign:"right", sorter:"number", width:105},
      {width:140,title:recuringTrans["totalSignificantErrorsValue"], field:"totalSignificantErrorsValue", bottomCalc:"sum", hozAlign:"center"},
      
    ];
  }else{

    $('#reportCommentsInterviews').hide();
    $('#reportCommentsDecisions').show();

    return [
      {title:"overallQualityData", field:"overallQuality-dataHidden", frozen:true, visible:false},
      {title:recuringTrans["totalApplicableValue"], field:"totalApplicableValue", bottomCalc:"sum", frozen:true, width:105, visible:false},
      {title:recuringTrans["totalCorrectValue"], field:"totalCorrectValue", hozAlign:"right", sorter:"number", bottomCalc:"sum", frozen:true, width:80, visible:false},
      {title:recuringTrans["totalMinorErrorsValue"], field:"totalMinorErrorsValue", bottomCalc:"sum", frozen:true, width:135, visible:false},
      {title:recuringTrans["percentageMinorErrorsValue"], field:"percentageMinorErrorsValue", frozen:true, width:105, visible:false},
      {title:recuringTrans["percentageSignificantErrorsValue"], field:"percentageSignificantErrorsValue", frozen:true, width:105, visible:false},
      {title:recuringTrans["overallQuality"], field:"overallQuality", headerSort:true, sorter:function(a, b, aRow, bRow, column, dir, sorterParams){
        //a, b - the two values being compared
        //aRow, bRow - the row components for the values being compared (useful if you need to access additional fields in the row data for the sort)
        //column - the column component for the column being sorted
        //dir - the direction of the sort ("asc" or "desc")
        //sorterParams - sorterParams object from column definition array

        var obj=  selectOptionsTrans['overallQuality'][0];
        a = Object.entries(obj).find(i => i[1] == a)[0];
        b = Object.entries(obj).find(i => i[1] == b)[0];
        
        return a - b; //you must return the difference between the two values
    }, width:160, headerFilter:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["caseFileReference"], field:"caseFileReference", headerSort:true,  headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["decisionMaker"], field:"decisionMaker", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["teamUnit"], field:"teamUnit", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {title:recuringTrans["countryOfOrigin"], field:"countryOfOrigin", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{}},
      {width:140,title:recuringTrans["specialNeeds"], field:"specialNeeds", sorter:function(a, b, aRow, bRow, column, dir, sorterParams){

        
        var obj=  selectOptionsTrans['specialNeeds'][0];
        a = Object.entries(obj).find(i => i[1] == a[0])[0];
        b = Object.entries(obj).find(i => i[1] == b[0])[0];

        return a - b; //you must return the difference between the two values
    }, headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, editorParams:{multiValueRow: true}},
      {width:282,title:recuringTrans["dateOfLodgingTheApplication"], headerSort:true, headerFilter:true, field:"dateOfLodgingTheApplication", headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
      {width:282,title:recuringTrans["dateOfInterview"], field:"dateOfInterview", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
     // {title:recuringTrans["languageOfTheInterview"], field:"languageOfTheInterview", headerSort:false, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"languageOfTheInterview"}},
     // {title:recuringTrans["legalRepresentativePresentDuringTheInterview"], headerSort:false, field:"legalRepresentativePresentDuringTheInterview", headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"legalRepresentativePresentDuringTheInterview"}},
      {width:282,title:recuringTrans["dateOfDecision"], field:"dateOfDecision", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},
      {title:recuringTrans["groundsForTheApplication"], headerSort:true, sorter:function(a, b, aRow, bRow, column, dir, sorterParams){

        var obj=  selectOptionsTrans['groundsForTheApplication'][0];
        a = Object.entries(obj).find(i => i[1] == a[0])[0];
        b = Object.entries(obj).find(i => i[1] == b[0])[0];

        return a - b; //you must return the difference between the two values
    }, width:140, field:"groundsForTheApplication", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"groundsForTheApplication"}},
      {title:recuringTrans["decisionOutcome"], field:"decisionOutcome", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"decisionOutcome"}},
      {title:recuringTrans["qualityAssessor"], field:"qualityAssessor", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"qualityAssessor"}},
      {width:282,title:recuringTrans["assesmentDate"], field:"assesmentDate", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], sorter:"date",  sorterParams:{format:"YY-MM-DD"},  headerFilter:dateFilterEditor, headerFilterFunc:dateFilterFunction},     
      //{title:recuringTrans["assessmentBasedOn"], field:"assessmentBasedOn", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"assessmentBasedOn"}},
      //{title:recuringTrans["additionalInformationSpecificToNationalSystem"], headerSort:true, field:"additionalInformationSpecificToNationalSystem", headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"additionalInformationSpecificToNationalSystem"}},
      {width:250,title:recuringTrans["decisionIssuedAccordingTimelines"], field:"decisionIssuedAccordingTimelines", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"decisionIssuedAccordingTimelines"}},
      {title:recuringTrans["conclusion"], field:"conclusion", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"], headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"conclusion"}},
      
      {title:recuringTrans["sexOfTheApplicant"], field:"sexOfTheApplicant", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"sexOfTheApplicant"}},
      {title:recuringTrans["ageOfTheApplicant"], field:"ageOfTheApplicant", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"ageOfTheApplicant"}},
      {width:200,title:recuringTrans["interviewConductedByDecisionMaker"], field:"interviewConductedByDecisionMaker", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"interviewConductedByDecisionMaker"}},
      {width:200,title:recuringTrans["numberOfPagesOfDecision"], field:"numberOfPagesOfDecision", headerSort:true, headerFilter:true, headerFilterPlaceholder:recuringTrans["filterPlaceholder"],headerFilter:"multiselectSelectize", headerFilterFunc:matchAnyFilter, headerFilterFuncParams:{fieldName:"numberOfPagesOfDecision"}},


      
      {title:recuringTrans["percentageCorrectValue"], field:"percentageCorrectValue", hozAlign:"right", sorter:"number", width:105},
      {width:140,title:recuringTrans["totalSignificantErrorsValue"], field:"totalSignificantErrorsValue", bottomCalc:"sum", hozAlign:"center"},

    ];
  }

}

$('input[name="selected_report"]').on('change', function(event) {
  var headerFilters =null;
  if(typeof reportTable !="undefined") {
    headerFilters = reportTable.getHeaderFilters();
  }

  if($('input[name="selected_report"]:checked').val()=='personal') {
    $('label[for="first_instance"]').css('background','#e8e8e8').css('color','#000');
    $('label[for="personal_report_radio"]').css('background','#58bc82').css('color','#fff');
    progressCompleted(tableDataPersonalInterviewForm,headerFilters);
  }else{
    $('label[for="personal_report_radio"]').css('background','#e8e8e8').css('color','#000');
    $('label[for="first_instance"]').css('background','#58bc82').css('color','#fff');
    progressCompleted(tableDataFirstInstanceDecision,headerFilters);
  }
});

$(document).on('change', '#filterManage .filterToggle input', function() {
  // Does some stuff and logs the event to the console
  let field = $(this).attr('id').replace('filterManage_','');
  if(this.checked == true){
    reportTable.showColumn(field);
    reportTable.redraw(true);
  }else{
    reportTable.hideColumn(field)
  }
   //reportTable.redraw(true); 
});

//custom header filter
var dateFilterEditor = function(cell, onRendered, success, cancel, editorParams){

	var container = $("<span></span>")
	//create and style input
	var start = $("<input class='selectize-input' type='date' placeholder='Start'/>");
	var end = $("<input class='selectize-input' type='date' placeholder='End'/>");

	container.append(start).append(end);

	var inputs = $("input", container);


	inputs.css({
		"padding":"4px",
		"width":"50%",
		"box-sizing":"border-box",
	})
	.val(cell.getValue());

	function buildDateString(){
    if(!start.val() && !end.val()) {
      return false;
    }

		return {
			start:start.val(),
			end:end.val(),
		};
	}

	//submit new value on blur
	inputs.on("change blur", function(e){
    success(buildDateString());
    createReportsChart();
	});

	//submit new value on enter
	inputs.on("keydown", function(e){
		if(e.keyCode == 13){
			success(buildDateString());
		}

		if(e.keyCode == 27){
			cancel();
		}
	});

	return container[0];
}

//custom filter function
function dateFilterFunction(headerValue, rowValue, rowData, filterParams){
    //headerValue - the value of the header filter element
    //rowValue - the value of the column in this row
    //rowData - the data for the row being filtered
    //filterParams - params object passed to the headerFilterFuncParams property

   	var format = filterParams.format || "YYYY/MM/DD";
   	var start = moment(headerValue.start);
   	var end = moment(headerValue.end);
   	var value = moment(rowValue, format)
   	if(rowValue){
   		if(start.isValid()){
   			if(end.isValid()){
   				return value >= start && value <= end;
   			}else{
   				return value >= start;
   			}
   		}else{
   			if(end.isValid()){
   				return value <= end;
   			}
   		}
   	}

    return true; //must return a boolean, true if it passes the filter.
}

function jsonDataToReport(folderSelect,callback) {
  
  //create a new object and only try to read json files
  var files = Object.assign({}, folderSelect.files);
  if(Object.keys(files).length<=0){
    alert('No files uploaded, please try again');
    return;
  }
  startProgressBar();


  let filesNumber = (Object.keys(files).length)  || 0 ;
  $.each(files, function(index, value) {
    if (value.name.slice(-4).toLowerCase() != "json") {
     delete files[index];
     filesNumber--;
    }
  });

  console.log(files);
  var json;
  var openDraftWarning = false;
  tableDataFirstInstanceDecision = [];
  tableDataPersonalInterviewForm = [];
  jsonLoadedArray = [];
  let formPages = pageByType("form");

  // files is a FileList of File objects. List some properties.
  //for (var file = 0, f; f = files[i]; i++) {
  var i;
  var f;
  for (i in files) {
    f = files[i];
    var reader = new FileReader();
    var counter = 0;
    // Closure to capture the file information.
    reader.onload = (function (theFile) {
      return function (e) {
        try {            
          json = JSON.parse(e.target.result);
         


          if(json.pageStatus != 'draft') {
            json['id'] = counter;
            counter++;
            jsonLoadedArray.push(json);
          }


          
          if ((!json["formName"] || !formPages.includes(json.formName)) && json.pageStatus != 'draft') {
            delete files[i];
            filesNumber--;
            if(filesNumber === (tableDataFirstInstanceDecision.length + tableDataPersonalInterviewForm.length)) {



              if(tableDataFirstInstanceDecision.length>0 && tableDataPersonalInterviewForm.length<=0) {
                $('input[name="selected_report"][value="first_instance"]').prop('checked', true).trigger('change');
                progressCompleted(tableDataFirstInstanceDecision);
  
              } else if(tableDataFirstInstanceDecision.length<=0 && tableDataPersonalInterviewForm.length>0) {
                $('input[name="selected_report"][value="personal"]').prop('checked', true).trigger('change');
                progressCompleted(tableDataPersonalInterviewForm);
  
              }

            }
            return;
          }
          $.each(selectOptionsTrans,function(key,value){


            if (typeof(json[key]) === "string") {
              //Create anew column with the data value for the overallQuality
              if (key === "overallQuality") {json[key+"-dataHidden"] = json[key];}
              //Combine the conclusion fields from both forms in order to have one less column shown to the user
              if (key === "interviewerAllowToTakeCorrectDecision" || key === "basedOnOverallObservations") {json["conclusion"] = value[0][json[key]];}
              
              json[key] = value[0][json[key]];
              //For multi-value fields
            } else if (typeof(json[key]) === "object") {
              $.each(json[key], function(fieldKey, fieldValue) {
                json[key][fieldKey] = value[0][json[key][fieldKey]];
              });
            }
          });

          // lets enable form switch
          // we must only load the report that is selected
          if(json.pageStatus != 'draft') {
            if(json["formName"]=='firstInstanceDecision') {
              tableDataFirstInstanceDecision.push(json);
            }else{
              tableDataPersonalInterviewForm.push(json);
            }
          }else{
            //open modal
            openDraftWarning = true;
            delete files[i];
            filesNumber--;
          }
          var importedfileTotals = tableDataFirstInstanceDecision.length + tableDataPersonalInterviewForm.length;
 
          percentCompleted = Math.round((importedfileTotals/filesNumber)*10000)/100;
          $(".progress-bar")[0].innerText = importedfileTotals+"/"+filesNumber;
          $('.progress-bar').css('width', percentCompleted+'%');
          if(filesNumber === importedfileTotals) {

            if(tableDataFirstInstanceDecision.length>0 && tableDataPersonalInterviewForm.length<=0) {
              $('input[name="selected_report"][value="first_instance"]').prop('checked', true).trigger('change');
              progressCompleted(tableDataFirstInstanceDecision);
            } else if(tableDataFirstInstanceDecision.length<=0 && tableDataPersonalInterviewForm.length>0) {
              $('input[name="selected_report"][value="personal"]').prop('checked', true).trigger('change');
              progressCompleted(tableDataPersonalInterviewForm);
            } else if(tableDataPersonalInterviewForm.length>0) {
              $('input[name="selected_report"][value="personal"]').prop('checked', true).trigger('change');
              progressCompleted(tableDataPersonalInterviewForm);
            } else if(tableDataFirstInstanceDecision.length>0) {
              $('input[name="selected_report"][value="first_instance"]').prop('checked', true).trigger('change');
              progressCompleted(tableDataPersonalInterviewForm);
            }
          }

        } catch (ex) {
          alert(recuringTrans["fileLoadError"] + ": " + ex);
        }

        if(openDraftWarning){
          $("#draftWarning").modal();
        }
      }
      
    })(f)    
  reader.readAsText(f);

} 

}
  function progressCompleted (tableData,headerFilters) {
    tabulatorCreateMainTable(tableData,headerFilters);
    $('.js-loading-bar').modal('hide');
    $("#jsonLoadFolder, #jsonLoadMultiple")[0].value ="";
    $(".progress-bar")[0].innerText = "";
    $('.progress-bar').css('width', '0%');
  }
var reportTable;
var hiddenCols = [];
var jsonLoadedArray = [];
var tableDataFirstInstanceDecision = new Array();
var tableDataPersonalInterviewForm = new Array();
function tabulatorCreateMainTable(tableData,headerFilters) {



  
  if(typeof headerFilters=='undefined') {
    headerFilters = null
  }
   
  reportTable = new Tabulator("#reportPageMainTable", {
    footerElement:"<button id=\"removeFilters\">"+ transValues['removeFilters'] +"</button><button id=\"csvExport\">" + transValues['csvExport'] + "</button>",
    layout:"fitDataFill",
    movableRows: true,
    movableColumns: true, //enable user movable columns
    height:"420px",
    placeholder: recuringTrans["tabulatorPlaceholder"],//"Select 'Import Folder' or 'Import Files' from the action menu to get started.",
    columns: tableColsForSelectedType(),
    dataFiltered:function(filters, rows){
      //filters - array of filters currently applied
      //rows - array of row components that pass the filters
      
      if (rows.length >= 1) {
        createReportsChart();
      }
    },
    dataLoaded:function(){
      tblColumns = this.getColumns();

      $('#filterManage ul li').hide();
      
      for (i=0; i< tblColumns.length; i++) {
        
        columnDef = tblColumns[i]["_column"].definition;

        let showColumn = (typeof columnDef.visible ==="undefined" || columnDef.visible==true);

        if($('#filterManage_'+ columnDef.field).length <= 0 && columnDef.visible===false) {
          hiddenCols.push(columnDef.field);
        }
        if (columnDef.headerFilter === "multiselectSelectize") {
          this.getColumn(columnDef.field).reloadHeaderFilter();
          selectizeReportSelect(columnDef.field);
        }
        if($('#filterManage_'+ columnDef.field).length <= 0 && showColumn) {
          // add the column 
          $('#filterManage ul').append('<li class="filterToggle" id="filterManage_'+ columnDef.field +'_item"><label for="filterManage_'+ columnDef.field +'">'+ columnDef.title +'</label> <input type="checkbox" id="filterManage_'+ columnDef.field +'" checked="checked" /></li>');  
        }
        $('#filterManage_'+ columnDef.field +'_item').show();
        

        if($.inArray(columnDef.field, hiddenCols)>0 || $('#filterManage_'+ columnDef.field, '#filterManage').is(':checked')===false) {
          tblColumns[i]["_column"].hide();
        }else{
          tblColumns[i]["_column"].show();
        }        
      }
      for(var key in headerFilters) {
        var fieldObject = headerFilters[key];
        try{
          this.getColumn(fieldObject.field).reloadHeaderFilter();
          this.setHeaderFilterValue(fieldObject.field,fieldObject.value);
          if(typeof fieldObject.value['start'] != 'undefined') {
            $('input[placeholder="Start"]','div[tabulator-field="'+ fieldObject.field +'"]').val(fieldObject.value['start']);
            $('input[placeholder="End"]','div[tabulator-field="'+ fieldObject.field +'"]').val(fieldObject.value['end']);
            // is a date
          }else{
            // not a date
            selectizeReportSelect(fieldObject.field,fieldObject.value); 
          }   
        
        }catch (ex) {
         
        }
      }

     
      initializeTotalsObserver();
      
      

    },
    tableBuilt:function(){
      $('.tabulator select').on("change", onChange);
      $('.tabulator select').on("blur", onChange);
      $('#removeFilters').click(function(){
        reportTable.clearHeaderFiltersNoReset();
      });

      $('#csvExport').click(function(){


        var todaysDate = new Date();
        var month = String(todaysDate.getMonth()).padStart(2, '0');
        var day = String(todaysDate.getDate()).padStart(2, '0');
        var year = todaysDate.getFullYear();
    
        var dateTimeFile = year+month+day;
    
        var pdfFileName = '';
        pdfFileName =  transValues['Report_details_decisions'] + dateTimeFile+'.csv';
        if($('input[name="selected_report"]:checked').val()=='personal') {
          pdfFileName = transValues['Report_details_interviews']  + dateTimeFile+'.csv';
        }
        pdfFileName =  pdfFileName;

        reportTable.download("csv", pdfFileName, {bom:true});
      });
      
    },
    
    
  });

  

  //We extend the tabulator functionality with our own in order to set and get the headerFilter Values
  reportTable.__proto__.saveFilterValues = function() {
    exportFilterValues(this.getHeaderFilters());
  };
  reportTable.__proto__.setColumnHeaderFilterValue = function(columnName, value) {
    reportTable.getColumn(columnName).reloadHeaderFilter();
    selectizeReportSelect(columnName);
    let selectColumn = $("#select-"+columnName).eq(0).data('selectize');
    if (selectColumn) {
      $.each(value, function (ind, val) {
        selectColumn.addItem(val,false);
      });
    }
  }
  reportTable.__proto__.loadFiltersJSON = function(json) {
    reportTable.clearHeaderFilters();
    $.each(json,function(key,val){

      if(moment(val.value.start, "YYYY-MM-DD", true).isValid() && moment(val.value.end, "YYYY-MM-DD", true).isValid()) {

        $('input[placeholder="Start"]','[tabulator-field="'+ val.field +'"]').val(val.value.start).change();

        $('input[placeholder="End"]','[tabulator-field="'+ val.field +'"]').val(val.value.end).change();
      } else if(moment(val.value.start, "YYYY-MM-DD", true).isValid()) {
      
        $('input[placeholder="Start"]','[tabulator-field="'+ val.field +'"]').val(val.value.start).change();
      
      }else if(moment(val.value.end, "YYYY-MM-DD", true).isValid()) {
      
        $('input[placeholder="End"]','[tabulator-field="'+ val.field +'"]').val(val.value.end).change();
      } else{
        
        reportTable.setColumnHeaderFilterValue(val.field, val.value);

      }

      
    });
  };

  //compare the given filters to the set headerr filters and only clear them
  reportTable.__proto__.clearHeaderFilters = function(json) {
    
    headerFilters = reportTable.getHeaderFilters();
    if (headerFilters.length === 0) return; //No header filters have been set, we have nothing to clear
    
 

    $.each(headerFilters, function(key,val){
      reportTable.clearHeaderFilter(val.field);
      reportTable.getColumn(val.field).reloadHeaderFilter();
      selectizeReportSelect(val.field);
    });

  }

  //Remove filters without resetting the data, when footer button is pushed
  reportTable.__proto__.clearHeaderFiltersNoReset = function() {
    
    if($('input[name="selected_report"]:checked').val()=='personal') {
      progressCompleted(tableDataPersonalInterviewForm,headerFilters);
      
    }else{
      progressCompleted(tableDataFirstInstanceDecision,headerFilters);
    }

  }

  reportTable.setData(tableData);
  if (tableData.length > 1) {
    createReportsChart();
  }
  
}
Tabulator.prototype.extendModule("edit", "editors", {
  multiselectSelectize:function(cell, onRendered, success, cancel, editorParams){

      //create and style input
      var cellValue = cell.getValue();
      input = document.createElement("select");
      input.multiple = true;
      var options = filterOptions(cell.getField());
 
      input.id = "select-"+cell.getField();
      input.style.class = "multiple";
      input.style.padding = "4px";
      input.style.width = "100%";
      input.style.boxSizing = "border-box";

      input.value = cellValue;

      var i = 0;
      $.each(options, function( index, val ) {
        if (typeof(val) === "object") {
          $.each(val, function(index, valM){
            option = document.createElement("option");
            option.text = valM;
            input.add(option, input[i++]);
          });
        } else {    
          option = document.createElement("option");
          option.text = val;
          input.add(option, input[i++]);
        }
      });

      function onChange(e) {
        fieldID = "select-"+cell.getField();
        fieldValue = $('#'+fieldID).val();
        
        if (fieldValue === [""]) success("");
        else success(fieldValue);
      }

      //submit new value on blur or change
      input.addEventListener("change", onChange);
      input.addEventListener("blur", onChange);

      //submit new value on enter
      input.addEventListener("keydown", function (e) {
          if (e.keyCode == 13) {
              success(input.value);
          }
          if (e.keyCode == 27) {
              cancel();
          }
      });

      return input;
  },
});
function onChange(e) {
  success(input.value.toUpperCase());
}

function selectizeReportSelect(field,items) {


  if(typeof items == 'undefined') {
    items = [];
  }

  $('[tabulator-field='+ field+'] .selectize-control').remove();
  return $('#select-'+field).selectize({
    plugins: ['remove_button'],
    delimiter: ',',
    persist: false,
    sortField: 'value',
    create: false,
    dropdownParent:'body',
    items: items,
    render: {
      item: function(data, escape) {
        return '<div>"' + escape(data.text) + '"</div>';
      }
    }, 
    onItemRemove: (value) => {
      if(typeof this.values !== 'undefined') {
        var filters =  reportTable.getHeaderFilters();
        var filterItemCount = 0;
        for(filter in filters){
          if(filters[filter].field == field) {
            filterItemCount = filters[filter].value.length;
          }  
        }

        tblColumns = reportTable.getColumns();
        
        for (i=0; i< tblColumns.length; i++) {
          columnDef = tblColumns[i]["_column"].definition;
          
          if (columnDef.field == field && filterItemCount==0) {
            
            reportTable.getColumn(columnDef.field).reloadHeaderFilter();
            selectizeReportSelect(columnDef.field);
          }
        }
      }
      $('.tabulator .tabulator-tableHolder').scrollLeft( $('.tabulator .tabulator-tableHolder').scrollLeft()+1 );
      // at one's peril
    },  
      onChange: (value, isOnInitialize) => {
        // typeof(value);
       
        reportTable.setHeaderFilterValue(field,value);
        selectizeReportSelect(field,value);
        createReportsChart(); 
        if(value.length<=0){
          $('#'+ field +'AppliedFilter').remove();
        }else if($('#'+ field +'AppliedFilter').length>0) {
          $('#' + field +'AppliedFilter', '#appliedFilters').replaceWith('<tr id="'+ field +'AppliedFilter"><td>'+ recuringTrans[field] +'</td><td>' + value +'</td></tr>')
        }else{
          $('#appliedFilters').append('<tr id="'+ field +'AppliedFilter"><td>'+ recuringTrans[field] +'</td><td>' + value +'</td></tr>');
        }
       
      }
  });
}

//custom filter function
function matchAnyFilter(headerValue,cellValue, rowData, filterParams){
  //headerValue - the value of the header filter element
  //cellValue- the value of the column in this row
  //rowData - the data for the row being filtered
  //filterParams - params object passed to the headerFilterFuncParams property
  if (headerValue.length === 0) return true;
  if (!cellValue) return false;
  var matched = false;
  values = headerValue;
  if (typeof(cellValue) === "object") {
    cellValue.forEach(function(val,index){
      if (matched === true) return;
      matched = isMatched(values, val);
    });
  } else matched =  isMatched(values, cellValue);
  
  return matched;
}
//Compares a cellValue to a list of Values
const isMatched = (values,cellValue) => {
  matched = false;
    values.forEach(function(val){
      if (val === cellValue) {
        matched = true;
      }
  });
  return matched; 
};

/** Creates lists of data from the report table for the given column*/
function filterOptions(fieldName){
  if (!reportTable) return;
	var list = {"":""};
	var data = reportTable.getData().map(a => a[fieldName]);

	data.forEach(function(item){
		if(typeof item !== "undefined"){
			list[item] = item;
		}
	});
	return list;
}

/* Calculate values and initializer report creation */
function createReportsChart() {
  addIndicatorReport();
  totalApplicable = reportTable.getCalcResults().bottom.totalApplicableValue;
  totalCorrect = reportTable.getCalcResults().bottom.totalCorrectValue;
  totalMinorerrors = reportTable.getCalcResults().bottom.totalMinorErrorsValue;
  totalSignificanterrors = reportTable.getCalcResults().bottom.totalSignificantErrorsValue;
  var assessmentData = [totalCorrect,totalMinorerrors,totalSignificanterrors];

  if (isNaN(totalApplicable)) { totalApplicable = 0; }
  if (isNaN(totalCorrect)) { totalCorrect = 0; }
  if (isNaN(totalMinorerrors)) { totalMinorerrors = 0; }
  if (isNaN(totalSignificanterrors)) { totalSignificanterrors = 0; }
  createAssessmentGraph(assessmentData);

  var qualityData = {high: 0,moderate: 0, low: 0};
  //Calculate quality totals


  var headerFilters = reportTable.getHeaderFilters();
  var hasFilters= true;
  var rowData = reportTable.getData("active");
  var rowInlineData = null;

  $.each( rowData, function( key, value ) { 
  //$.each(reportTable.getData(), function( key, value ) { 
 
    rowInlineData = value['overallQuality-dataHidden'];
    // var obj=  selectOptionsTrans['overallQuality'][0];
    // var a = Object.entries(obj).find(i => i[1] == value.innerText)[0];
    //switch(value['overallQuality-dataHidden']) {
    switch(rowInlineData) {
      case "03":
        qualityData.low++;
        break;
      case "02":
        qualityData.moderate++;
        break;
      case "01":
        qualityData.high++;
        break;
    }
  });

  createQualityGraph([qualityData.high, qualityData.moderate, qualityData.low]);
  $("#totalApplicableValueIdRep").val(totalApplicable);
  $("#totalCorrectValueIdRep").val(totalCorrect);
  $("#totalMinorErrorsValueIdRep").val(totalMinorerrors);
  $("#totalSignificantErrorsValueIdRep").val(totalSignificanterrors);

  correctPercentage = (totalCorrect*100/totalApplicable).toFixed(2);
  if (isNaN(correctPercentage)) { correctPercentage = 0; }
  $("#percentageCorrectValueIdRep").val(correctPercentage+"%"); 

  minorErrorsPercentage = (totalMinorerrors*100/totalApplicable).toFixed(2);
  if (isNaN(minorErrorsPercentage)) { minorErrorsPercentage = 0; }
  $("#percentageMinorErrorsValueIdRep").val(minorErrorsPercentage+"%"); 
  
  significantErrorsPercentage = (totalSignificanterrors*100/totalApplicable).toFixed(2);
  if (isNaN(significantErrorsPercentage)) { significantErrorsPercentage = 0; }
  $("#percentageSignificantErrorsValueIdRep").val(significantErrorsPercentage+"%"); 
 
  $(document).ready(function () { 

    var rows = reportTable.getRows('active');
    var rowPercentageMinorErrorsValue = 0;
    $.each(rows, function( index, value ) {
      rowPercentageMinorErrorsValue = parseFloat(value.getData().percentageMinorErrorsValue.replace('%',''));
      if(value.getData().totalSignificantErrorsValue == 0 && rowPercentageMinorErrorsValue < 20 && value.getData().totalCorrectValue>0) {
        $('[tabulator-field="percentageCorrectValue"].tabulator-cell',value._row.element).css('background','#548235');
      }else if(value.getData().totalSignificantErrorsValue == 0 && rowPercentageMinorErrorsValue >= 20) {
        $('[tabulator-field="percentageCorrectValue"].tabulator-cell',value._row.element).css('background','#2f5597');
      }else if(value.getData().totalSignificantErrorsValue > 0) {
        $('[tabulator-field="percentageCorrectValue"].tabulator-cell',value._row.element).css('background','#c55a11');
      }

    });
    ///$('[tabulator-field="percentageCorrectValue"].tabulator-cell').css('background','rgb(112,173,71)');

    
    if($('.tabulator-calcs-bottom > [tabulator-field=percentageCorrectValue]').length>0)
      $('.tabulator-calcs-bottom > [tabulator-field=percentageCorrectValue]')[0].innerText = correctPercentage+"%";
    if($('.tabulator-calcs-bottom > [tabulator-field=percentageMinorErrorsValue]').length>0)
      $('.tabulator-calcs-bottom > [tabulator-field=percentageMinorErrorsValue]')[0].innerText = minorErrorsPercentage+"%";
    if($('.tabulator-calcs-bottom > [tabulator-field=percentageSignificantErrorsValue]').length>0)
      $('.tabulator-calcs-bottom > [tabulator-field=percentageSignificantErrorsValue]')[0].innerText = significantErrorsPercentage+"%";
    if($('.tabulator-calcs-bottom > [tabulator-field=overallQuality]').length>0)
      $('.tabulator-calcs-bottom > [tabulator-field=overallQuality]')[0].innerText = recuringTrans["qualityHigh"].charAt(0)+":"+qualityData.high+" "+recuringTrans["qualityModerate"].charAt(0)+":"+qualityData.moderate+" "+recuringTrans["qualityLow"].charAt(0)+":"+qualityData.low;
  });



  // Set the number of cases. The false in the getDataCount means that we want to know the filtered rows and not the total available
  $("#numberOfCasesValueIdRep").val(reportTable.getDataCount("active"));
  // Find minimum and maximum of assessment date
  var minDate = '2100-12-31';
  var maxDate = '1900-01-01';
  $.each( $('.tabulator-tableHolder > .tabulator-table > .tabulator-row > [tabulator-field=assesmentDate]'), function( key, value ) {
    if (value.innerText < minDate) { minDate = value.innerText;} 
    if (value.innerText > maxDate) { maxDate = value.innerText;}
  });
  $("#dateFromValueIdRep").val(moment(minDate).format('DD/MM/YYYY'));
  $("#dateToValueIdRep").val(moment(maxDate).format('DD/MM/YYYY'));
  
  

}

//Progress bar
function startProgressBar() {
  var $modal = $('.js-loading-bar');
  $modal.modal('show');
}

 //Observe when totals value changes
 function initializeTotalsObserver (){
   // totalApplicableValue no longer part of the table, and not in the dom for selection
  //if(('.tabulator-calcs-bottom [tabulator-field="totalApplicableValue"]').length>0){
    var targetNode = document.querySelector('.tabulator-calcs-bottom [tabulator-field="totalApplicableValue"]');
    // Options for the observer (which mutations to observe)
    var observerConfig = { attributes: true, childList: true, subtree: true };
    // Create an observer instance linked to the callback function
    var totalsObserver = new MutationObserver(createReportsChart);
    totalsObserver.observe(targetNode, observerConfig);
  //}
 }

 function array_flip( trans )
 {
     var key, tmp_ar = {};
 
     for ( key in trans )
     {
         if ( trans.hasOwnProperty( key ) )
         {
             tmp_ar[trans[key]] = key;
         }
     }
 
     return tmp_ar;
 }